/***********************************************************************
*  Copyright (c) 1996, 1997 Phaos Technology Corp. All rights reserved.
***********************************************************************/

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;

// Import Phaos SSLava Toolkit APIs
import crysec.*;
import crysec.SSL.*;

// Extend to use SSL
public class SSLHelloImpl extends UnicastRemoteObject implements Hello
{
  private String name;

  public SSLHelloImpl(String s) throws RemoteException
  {
    name = s;
  }

  public String sayHello() throws RemoteException
  {
    return "SSL Hello World!";
  }

  public static void main(String args[])
  {
    try
      {
	// initialize server certificate
	SSLCertificate cert = new SSLCertificate();
	cert.certificateList = new Vector();
	cert.certificateList.addElement(new X509(new File("server-cert.der")));
	cert.certificateList.addElement(new X509(new File("ca-cert.der")));

	// initialize SSL context object
	SSLParams params = new SSLParams();
	params.setServerCert(cert);
	params.setRequestClientCert(true); // require client authentication

	RMISocketFactory.setSocketFactory(new SSLSocketFactory(params));
	
	System.setSecurityManager(new RMISecurityManager());

	SSLHelloImpl o = new SSLHelloImpl("HelloServer");
	Naming.rebind("/HelloServer", o);
	System.out.println("HelloServer bound in registry");
      }
    catch (Exception e) {e.printStackTrace();}
  }
}
