
/***********************************************************************
*  Copyright (c) 1996, 1997 Phaos Technology Corp. All rights reserved.
***********************************************************************/

import java.io.*;
import java.util.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;

import sun.rmi.registry.*;

// Import Phaos SSLava Toolkit APIs
import phaos.crysec.*;
import phaos.crysec.SSL.*;

public class SSLRegistryImpl extends RegistryImpl implements Registry
{
  public SSLRegistryImpl() throws RemoteException
  {
  }

  public SSLRegistryImpl(int port) throws RemoteException
  {
    super(port);
  }

  public static void main(String arg[])
  {
    try
      {
	int port = Registry.REGISTRY_PORT;
	if (arg.length == 1)
	  port = Integer.parseInt(arg[0]);

	// initialize server certificate
	SSLCertificate cert = new SSLCertificate();
	cert.certificateList = new Vector();
	cert.certificateList.addElement(new X509(new File("server-cert.der")));
	cert.certificateList.addElement(new X509(new File("ca-cert.der")));

	// initialize SSL context object
	SSLParams params = new SSLParams();
	params.setServerCert(cert);
	params.setRequestClientCert(true); // require client authentication
	short cs[] = { SSLParams.SSL_DHE_DSS_EXPORT_WITH_DES40_CBC_SHA,
	               SSLParams.SSL_RSA_WITH_3DES_EDE_CBC_SHA };
        params.setServerCipherSuites(cs); 

	RMISocketFactory.setSocketFactory(new SSLSocketFactory(params));
	
	System.setSecurityManager(new RMISecurityManager());

	SSLRegistryImpl o = new SSLRegistryImpl(port);

	while (true)
	  {
	    try
	      {
		Thread.sleep(Long.MAX_VALUE);
	      }
	    catch (InterruptedException e) {}
	  }
      }
    catch (Exception e) {e.printStackTrace();}
  }
}

