
/***********************************************************************
*  Copyright (c) 1996, 1997 Phaos Technology Corp. All rights reserved.
***********************************************************************/

import java.net.*;
import java.io.*;
import java.rmi.server.*;

// Import Phaos SSLava Toolkit APIs
import phaos.crysec.SSL.*;

// Extend standard RMISocketFactory to use SSL.
public class SSLSocketFactory extends RMISocketFactory
{
  // SSL context object
  protected SSLParams params;
  
  public SSLSocketFactory()
  {
    this(new SSLParams());
  }

  public SSLSocketFactory(SSLParams p)
  {
    params = p;
  }

  public Socket createSocket(String host, int port) throws IOException
  {
    return new SSLSocket(host, port, params);
  }

  public ServerSocket createServerSocket(int port) throws IOException
  {
    return new SSLServerSocket(port, params);
  }
}

